#ifndef CIVPGCONN_H
#define CIVPGCONN_H
#include <libpq-fe.h>

#include "CivDbConn.h"

/**
 postgress ݿ
*/
class DBEXPORT CivPgConn: public CivDbConn
{
public:
	CivPgConn(char* uri);
	virtual ~CivPgConn();

	/**
	*@brief ݿ⣬йʵ
	*/
	bool open() override;

	/**
	*@brief رݿӣйʵ
	*/
	void close() override;

	/**
	*@brief жĳűǷڣжϷݿйأӳٵʵ
	*@tableName: 
	*/
	bool tableExist(StrQuote tableName)override;

	/**
	*@brief ִsql
	*@sql: Ҫִеsql
	*/
	 bool execSql(StrQuote sql) override;
	 bool getNode(CivNode& node) override;
	 bool getPipe(CivPipe& pipe) override;
	 bool getTank(CivTank& tank) override;
	 bool getValve(CivValve& valve) override;
	 bool getPumps(CivPumps& pump) override;
	 bool getReservoirs(CivReservoirs& reservoirs) override;
	 bool getEmitters(CivEmitters& emitter) override;
	 bool getCoordinates(CivCoordinates& coord) override;
	 bool getMixing(CivMixing& mixing) override;
	 bool getParameter(std::vector<CivParameter>& param) override;
	 bool getPatterns(CivPatterns& patterns) override;
	 bool getCurves(CivCurves& curves) override;
	 bool getDemands(CivDemands& demands) override;
	 bool getSources(CivSources& sources) override;
	 bool getStatus(CivStatus& status) override;
	 bool getQuality(CivQuality& quality) override;
	 bool getLabels(CivLabels& labels) override;
	 bool getTags(CivTags& tags) override;

	 /**
	  *@brief 
	  *@tableName: 
	  *@schema:
	  *@tableType߽ͣ
	  */
	 bool createTable(CivTableTemp& temp) override;

	 /**
	 *@brief ֵֶɾ
	 *@table
	 *@filedNameֶ
	 *@fieldValueֵֶ
	 */
	 bool deleteByField(StrQuote table, StrQuote filedName, StrQuote fieldValue) override;
	 bool updateNodeByInterval(StrQuote currDate, StrQuote interval) override;
	 bool updateLinkByInterval(StrQuote currDate, StrQuote interval) override;
	 /**
	  *@brief µ
	  *@nodeItemsҪµֵ
	  */
	 bool updateNode(const NodeResultItems& nodeItems) override;

	 /**
	  *@brief ߱
	  *@lineItems: 
	  */
	 bool updateLink(const LinkResultItems& lineItems) override;
private:
	PGconn* mConn; // Ӷ
	PGresult* mResult;  // ѯ

	char* mUri;
};

#endif // !CIVPGCONN_H
