#pragma once
#include<string>
#include<set>  
#include "CivInp.h"
#include "CivSysLog.h"
#include "CivSimulResultCache.h"

class CivDbConnection;
class CivDbConn;

/**
* ˮ
*/
class  CivHydrCalc
{
public:
	CivHydrCalc(char* uri, std::string netName);
	~CivHydrCalc();

	/**
	 *@brief ˮģ
	 *@inpFile:inpļ
	 *@rptFile: ļ
	 *@binOutFile: ļ
	 */
	bool hydrSimulation(char* inpFile, char* rptFile, char* binOutFile);

	/**
	 *@brief ˮģ
	 *@inpFile:inpļ
	 *@rptFile: ļ
	 *@binOutFile: ļ
	 */
	bool qualitySimulation(char* inpFile, char* rptFile, char* binOutFile);

	bool getDataByInterval( char* date, char* interval);

	/**
	*@brief inpļ
	*/
	bool exportInp(char* fileName);

private:
	/**
	*@brief ֶ˳д
	*@table:
	*@inp: inpļ
	*/
	void assemble(const std::string& table, CivInp& inp);


	/*
	*@brief ȡڵ
	*@time ʱ
	*/
	void getNodeResult(short time);

	/*
	*@brief ȡ߼
	*@time ʱ
	*/
	void getLinkResult(short time);

	/*
	*@brief ȡڵˮʼ
	*@time ʱ
	*/
	void getNodeQuality(short time);

	/*
	*@brief ȡˮֵ
	*@time ʱ
	*/
	void getLinkQuality(short time);

private:
	CivDbConnection* mDbConn;
	CivDbConn* mPgConn;
	std::string mNetname;

	CivSimulResultCache mResultCache; // 洢ģ
};


