#pragma once
#include "CivSimulResultCache.h"
#include "CivNewInp.h"

class CivDbConn;
/**
ˮģ
*/
class CivHydrSimulation
{
public:
	explicit CivHydrSimulation();
	explicit CivHydrSimulation(CivDbConn* dbConn);
	~CivHydrSimulation();

	/**
	 *@biref עݿ
	 *@dbConnݿָ
	 */
	void registDb(CivDbConn* dbConn);

	/**
	*@brief ˮģ
	*/
	bool hdyrSimulation();

	/**
	*@brief ˮģ⣬ˮ䣬ѧ
	*/
	bool qualitySimulation();

	/**
	*@brief ׷ٷȻʽˮʷ
	*@snNode׷ٵĽڵ
	*@hours: Сʱ
	*/
	bool trackingSimulation(char* snNode, int hours);

	/**
	*@brief inpļ
	*@analyType: ˮʷͣˮ䣬׷٣none
	*@qulityName:  ׷ٽڵֵ߻
	*/
	bool convertInp(const QualityAnalyType analyType, const std::string& qulityName);

	/**
	*@brief ȡ׷ٽֵ
	*@hours׷ٵСʱ
	*/
	void getTrackingResult(int hours, std::string& result);

	/**
	*@brief ͬһֻһģĽֵǰ֮ǰģĽֵ
	*@dbConn: ݿӶָ
	*@date: 
	*/
	bool  clearSamePeriodValue(CivDbConn* dbConn, const std::string& date);

	/**
	*@brief ʱģݵgisģУĬϸʱ
	*@dbConn: ݿӶָ
	*@time: ʱ
	*/
	bool updateLastestDataToGisNet(CivDbConn* dbConn,const std::string& time);

	/**
	*@brief ˢµģ
	*/
	bool brushingResult();
	/*
		inpļļļúͻȡ
	*/
	inline char*  getInpFile();
	inline void setInpFile(const std::string& inpFile);

	inline char* getRptFile();
	inline void setRptFile(const std::string& rptFile);

	inline char* getBinFile();
	inline void setBinFile(const std::string& binFile);

private:

	/**
	*@brief ˮʼ
	*/
	bool qualityCompute();
	void getNodeResult(short time);
	void getLinkResult(short time);
    void getNodeQuality(short time);
    void getLinkQuality(short time);

private:
	CivDbConn* mDbConn;
	CivSimulResultCache mResultCache; // 洢ģ

	std::string mInpFile; // inpļ
	std::string mRptFile; // ļ
	std::string mBinFile;// ļ
};
